import 'package:jsonstreamreader/jsonstreamreader.dart';

void main() {
  RemoteSource f =
      new RemoteSource('https://jsonplaceholder.typicode.com/posts');
  f.setBody({'userId': '1'});
  Streamer s = new Streamer(f, chunksize: 100);
  Reader r = new Reader(s, combine: 1);
  r.trailing((dynamic value, String key) {
    print("key is ${key} and value is ${value}");
  });
  r.progress((p) {
    print(p);
  }).done(() {
    print('Completed');
  }).fail((error) {
    print(error);
  });
  f.downloaded.listen((onData) {
    //File will always be download before parsing is done
    //but parsing is started as soon as data is available,i.e while the file is downloading
    print('File has been downloaded');
  });
  f.download();
}
