import 'dart:async';

import 'filestate.dart';

class FileStateProvider {
  static const WAITING = 1;
  static const CALLED = 2;
  static const COMPLETED = 3;
  StreamController<FileState> _next =
      new StreamController<FileState>.broadcast();
  //length:state
  Map<int, List<int>> calls = new Map<int, List<int>>();
  close() {
    _next.close();
  }

  pushState(int length, int state) {
    if (state == CALLED) {
      if (calls[length] == null) {
        calls[length] = new List<int>();
        calls[length].add(state);
      } else {
        calls[length].add(state);
      }
    }
    List<int> deletes = [];
    List<FileState> execute = new List<FileState>();
    calls.forEach((int length1, List<int> states) {
      if (state == WAITING) {
        if (length >= length1) {
          deletes.add(length1);
          if (!execute.contains(length)) {
            execute.add(new FileState(length));
          }
          return;
        }
      } else if (state == COMPLETED) {
        deletes.add(length1);
        if (!execute.contains(length)) {
          execute.add(new FileState(length));
        }
        return;
      }
    });
    deletes.forEach((int del) {
      calls.remove(del);
    });
    if (execute.length > 0) {
      execute.forEach((ex) {
        _next.add(ex);
      });
    }
  }

  Stream<FileState> ready() {
    return _next.stream;
  }
}
